#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
using namespace std;
#define REP(i,n)	for(int i=0,_n=(n);i<_n;++i)
#define REPD(i,n)	for(int i=(n-1);i>=0;--i)
#define FOR(i,s,k)	for(int i=(s),_k=(k);i<=_k;++i)
#define FORD(i,s,k)	for(int i=(s),_k=(k);i>=_k;--i)
#define FORE(it,q)	for(__typeof((q).begin())it=(q).begin();it!=(q).end();++it)
#define FORED(it,q)	for(__typeof((q).rbegin())it=(q).rbegin();it!=(q).rend();++it)
#define FOREACH(it,f,l)	for(__typeof(f)it=f;it!=l;++it)
#define FOREACHD(it,f,l)	for(__typeof(f)it=l;it--!=f;)

#define X -1
#define PLUS -2
#define MINUS -3
#define MUL -4
#define DIV -5
#define LBR -6
#define RBR -7

const double PI = M_PI;
const double PI25 = 2.5 * M_PI;

int pr(int c) {
	if (c == LBR || c == RBR) return 0;
	else if (c == PLUS || c == MINUS) return 1;
	else return 2;
}

vector<int> * trans(char * s) {
	fprintf(stderr, "\"%s\"\n", s);
	vector<int> * v = new vector<int>();
	while (*s != '\0') {
		if (*s == '+') v->push_back(PLUS);
		else if (*s == '-') v->push_back(MINUS);
		else if (*s == '*') v->push_back(MUL);
		else if (*s == '/') v->push_back(DIV);
		else if (*s == '(') v->push_back(LBR);
		else if (*s == ')') v->push_back(RBR);
		else if (*s == 'x') v->push_back(X);
		else {
			int num = 0;
			while (isdigit(*s)) { num = 10 * num + (*s - '0'); ++s; }
			v->push_back(num);
			--s;
		}
		++s;
	}
	/*FORE(it, *v) {
		fprintf(stderr, "-- %d\n", *it);
	}*/
	return v;
}

vector<int> * onp(vector<int> * v) {
	vector<int> * res = new vector<int>();
	stack<int> st;
	FORE(it, *v) {
		if (*it >= 0 || *it == X) res->push_back(*it);
		else if (*it == LBR) st.push(*it);
		else if (*it == RBR) {
			while (st.top() != LBR) {
				res->push_back(st.top());
				st.pop();
			}
			st.pop();
		} else {
			int prior = pr(*it);
			while (!st.empty() && pr(st.top()) >= prior) {
				res->push_back(st.top());
				st.pop();
			}
			st.push(*it);
		}
	}
	while (!st.empty()) {
		res->push_back(st.top());
		st.pop();
	}
	/*FORE(it, *res) {
		fprintf(stderr, "%d\n", *it);
	}*/
	return res;
}

vector<int> * _R;
vector<int> * _T;

double compute(vector<int> * v, double x) {
	stack<double> st;
	FORE(it, *v) {
		double v;
		if (*it == PLUS) {
			v = st.top();
			st.pop();
			v += st.top();
			st.pop();
			st.push(v);
		} else if (*it == MINUS) {
			v = -st.top();
			st.pop();
			v += st.top();
			st.pop();
			st.push(v);
		} else if (*it == MUL) {
			v = st.top();
			st.pop();
			v *= st.top();
			st.pop();
			st.push(v);
		} else if (*it == DIV) {
			v = 1/st.top();
			st.pop();
			v *= st.top();
			st.pop();
			st.push(v);
		} else if (*it == X) {
			st.push(x);
		} else {
			st.push(*it);
		}
	}
	
	return st.top();
}

double R(double x) {
	return compute(_R, x);
}

double T(double x) {
	return compute(_T, x);
}

bool testcase() {
	double H, B;
	scanf("%lf%lf\n", &H, &B);
	if (H == 0.0 && B == 0.0) return false;
	char __R[1001], __T[1001];
	gets(__R);
	gets(__T);
	
	vector<int> * tmp = trans("1/x");
	_R = onp(tmp);
	delete tmp;
	tmp = trans("2-x*x");
	_T = onp(tmp);
	delete tmp;
	 
	for (double i = 0.0 ; i <= 10 ; i += 1) {
		printf("%lf %lf\n", R(i), T(i));
	}
	
	return 1;
}


int main() {
	while(testcase());
	return 0;
}

